Name:           cinnamon
Version:        1.9.1
Release:        19%{?dist}
Summary:        Window management and application launching for GNOME
License:        GPLv2+ and LGPLv2+
URL:            http://cinnamon.linuxmint.com
#Because linuxmint upstream refuses to host pristine upstream tarballs
Source0:        http://leigh123linux.fedorapeople.org/pub/%{name}/source/%{name}-%{version}.tar.gz
#wget https://github.com/linuxmint/Cinnamon/archive/%{version}.tar.gz -O %{name}-%{version}.tar.gz

Source1:        cinnamon-fedora.gschema.override
Source2:        cinnamon-screensaver.desktop
Source3:        cinnamon2d-screensaver.desktop
Source4:        http://leigh123linux.fedorapeople.org/pub/gnome-settings-daemon-compat/source/gnome-settings-daemon-compat-3.6.4-1.tar.xz
Source5:        input-source-switcher.desktop

Patch0:         gnome-3.8-compat.patch
Patch1:         background.patch
Patch2:         idle-dim.patch
Patch3:         keyboard_applet.patch
Patch4:         screensaver.patch
Patch5:         bluetooth_obex_transfer.patch
Patch6:         autostart_nemo.patch
Patch7:         remove_GC.patch
Patch8:         menu_editor.patch

%global clutter_version 1.12.2
%global gobject_introspection_version 1.34.2
%global muffin_version 1.8.2
%global json_glib_version 0.13.2

BuildRequires:  clutter-devel >= %{clutter_version}
BuildRequires:  dbus-glib-devel
BuildRequires:  desktop-file-utils
BuildRequires:  gjs-devel >= 1.32.0
BuildRequires:  glib2-devel
BuildRequires:  GConf2-devel
BuildRequires:  gnome-menus-devel
BuildRequires:  gnome-desktop3-devel
BuildRequires:  gobject-introspection >= %{gobject_introspection_version}
BuildRequires:  json-glib-devel >= %{json_glib_version}
BuildRequires:  upower-devel
BuildRequires:  NetworkManager-glib-devel
BuildRequires:  polkit-devel
BuildRequires:  libgudev1-devel
# for screencast recorder functionality
BuildRequires:  gstreamer-devel
BuildRequires:  gtk3-devel
BuildRequires:  intltool
BuildRequires:  libcanberra-devel
BuildRequires:  libcroco-devel
BuildRequires:  libgnome-keyring-devel
BuildRequires:  libsoup-devel
BuildRequires:  pkgconfig(libnm-glib)
BuildRequires:  libXfixes-devel >= 5.0
# used in unused BigThemeImage
BuildRequires:  librsvg2-devel
BuildRequires:  muffin-devel >= %{muffin_version}
BuildRequires:  pulseaudio-libs-devel
%ifnarch s390 s390x
BuildRequires:  gnome-bluetooth-libs-devel >= 2.91
BuildRequires:  gnome-bluetooth >= 2.91
%endif
# Bootstrap requirements
BuildRequires: gtk-doc gnome-common
# mediia keys
BuildRequires:  gsettings-desktop-schemas-devel
BuildRequires:  libnotify-devel
BuildRequires:  xorg-x11-proto-devel
BuildRequires:  glib2-devel
BuildRequires:  lcms2-devel
BuildRequires:  colord-devel
%ifnarch s390 s390x %{?rhel:ppc ppc64}
BuildRequires:  libwacom-devel
BuildRequires:  xorg-x11-drv-wacom-devel
%endif
BuildRequires:  libXtst-devel

Requires:       gnome-menus%{?_isa} >= 3.0.0-2
# wrapper script uses to restart old GNOME session if run --replace
# from the command line
Requires:       gobject-introspection%{?_isa} >= %{gobject_introspection_version}
# needed for loading SVG's via gdk-pixbuf
Requires:       librsvg2%{?_isa}
# needed as it is now split from Clutter
Requires:       json-glib%{?_isa} >= %{json_glib_version}
Requires:       upower%{?_isa}
Requires:       polkit%{?_isa} >= 0.100
# needed for session files
Requires:       gnome-session
# needed for schemas
Requires:       at-spi2-atk%{?_isa}
# needed for on-screen keyboard
Requires:       caribou%{?_isa}
# needed for the user menu
Requires:       accountsservice-libs
Requires:       muffin%{?_isa} >= %{muffin_version}
# needed for settings
Requires:       pygobject2
Requires:       dbus-python
Requires:       python-lxml
Requires:       gnome-python2-gconf
Requires:       python-pillow
# nemo is a RequiredComponents in the session files
Requires:       nemo
# gnome-screensaver is a RequiredComponents in the session files
Requires:       gnome-screensaver

Obsoletes:      cinnamon-2d
Obsoletes:      cinnamon-settings
Obsoletes:      cinnamon-menu-editor
Obsoletes:      cinnamon <= 1.8.0-1


%description
Cinnamon is a Linux desktop which provides advanced
 innovative features and a traditional user experience.

The desktop layout is similar to Gnome 2. 
The underlying technology is forked from Gnome Shell.
The emphasis is put on making users feel at home and providing
 them with an easy to use and comfortable desktop experience.

%prep
%setup -q -T -b4 -n gnome-settings-daemon-compat-3.6.4-1
%setup -q -n Cinnamon-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
NOCONFIGURE=1 ./autogen.sh

%build
%configure --disable-static             \
           --disable-rpath              \
           --disable-schemas-compile    \
           --enable-introspection=yes   \
           --enable-compile-warnings=no 


make %{?_smp_mflags} V=1

# media-keys-helper
cd ../gnome-settings-daemon-compat-3.6.4-1
autoreconf -fi
%configure --libexecdir=%{_libexecdir}/%{name} --disable-static --disable-ibus \
 --disable-cups --disable-smartcard-support --disable-packagekit
make %{?_smp_mflags} V=1 -C plugins/common
make %{?_smp_mflags} V=1 -C plugins/media-keys
make %{?_smp_mflags} V=1 -C plugins/keyboard
make %{?_smp_mflags} V=1 -C plugins/automount

%install
%{make_install} INSTALL='install -p'

pushd ../gnome-settings-daemon-compat-3.6.4-1
%{make_install} -C plugins/media-keys INSTALL='install -p'
%{make_install} -C plugins/keyboard INSTALL='install -p'
%{make_install} -C plugins/automount INSTALL='install -p'
popd

# Remove .la file
rm -rf $RPM_BUILD_ROOT/%{_libdir}/cinnamon/libcinnamon.la

# Remove the unwanted keyboard bits
rm -rf $RPM_BUILD_ROOT/%{_libdir}/gnome-settings-daemon-3.0/
rm -rf $RPM_BUILD_ROOT/%{_datadir}/gnome-settings-daemon/

install -D -m 0644 %{SOURCE1} $RPM_BUILD_ROOT/%{_datadir}/glib-2.0/schemas/cinnamon-fedora.gschema.override

# Add autostart files for gnome-screensaver
install -pm 0644 %{SOURCE2} %{SOURCE3} $RPM_BUILD_ROOT/%{_datadir}/applications/

# Add autostart files for input-source-switcher
install -m 0755 -d $RPM_BUILD_ROOT/%{_sysconfdir}/xdg/autostart/
install -pm 0644 %{SOURCE5} $RPM_BUILD_ROOT/%{_sysconfdir}/xdg/autostart/

# Fix permission
chmod +x $RPM_BUILD_ROOT/%{_bindir}/cinnamon-launcher-creator
chmod +x $RPM_BUILD_ROOT/%{_bindir}/cinnamon3d

desktop-file-validate $RPM_BUILD_ROOT/%{_sysconfdir}/xdg/autostart/input-source-switcher.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon2d.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-add-panel-launcher.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-menu-editor.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-screensaver.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon2d-screensaver.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/gnome-fallback-media-keys-helper.desktop
desktop-file-validate $RPM_BUILD_ROOT/%{_datadir}/applications/gnome-fallback-mount-helper.desktop

desktop-file-install                                 \
 --add-category="Utility"                            \
 --remove-category="DesktopSettings"                 \
 --remove-key="Encoding"                             \
 --add-only-show-in="GNOME"                          \
 --delete-original                                   \
 --dir=$RPM_BUILD_ROOT/%{_datadir}/applications       \
 $RPM_BUILD_ROOT/%{_datadir}/applications/cinnamon-settings.desktop

%find_lang %{name}

%postun
if [ $1 -eq 0 ] ; then
    /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :
fi

%posttrans
    /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :

%files -f %{name}.lang
%doc COPYING README
%{_bindir}/*
%{_sysconfdir}/xdg/menus/*
%{_sysconfdir}/xdg/autostart/*
%{_datadir}/applications/*
%{_datadir}/dbus-1/services/org.Cinnamon.HotplugSniffer.service
%{_datadir}/desktop-directories/*
%{_datadir}/glib-2.0/schemas/org.cinnamon.gschema.xml
%{_datadir}/glib-2.0/schemas/cinnamon-fedora.gschema.override
%{_datadir}/gnome-session/sessions/*
%{_datadir}/xsessions/*
%{_datadir}/cinnamon/
%{_libdir}/cinnamon/
%{_libexecdir}/cinnamon/
#No choice but to do this. Filing a bug with upstream on this.
%{_prefix}/lib/cinnamon*/
%{_mandir}/man1/*

%changelog
* Tue Jul 23 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.9.1-19
- fix permissions on cinnamon3d

* Mon Jul 22 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.9.1-18
- fix permissions on cinnamon-launcher-creator

* Tue Jul 16 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-17
- add patch to fix cinnamon-menu-editor

* Fri Jul 12 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-16
- remove GC from cinnamon-global.c

* Wed Jul 10 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-15
- fix input-source-switcher autostart

* Wed Jul 10 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-14
- fix input-source-switcher

* Fri Jun 14 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-13
- spec file clean up

* Thu Jun 13 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-12
- Fix automount

* Thu Jun 13 2013 Dan Horák <dan[at]danny.cz> - 1.9.1-11
- fix build on s390(x) - no wacom there

* Wed Jun 12 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-10
- fix the screensaver tab in cinnamon-settings

* Sun Jun 09 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-9
- add requires gnome-screensaver

* Sun Jun 09 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-8
- Fix media keys

* Thu Jun 06 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-7
- change how the screen lock autostarts

* Thu Jun 06 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-6
- add requires nemo

* Thu Jun 06 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-5
- autostart nemo differently so we dont squash nautilus

* Thu Jun 06 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-4
- Patch so screen lock uses gnome-screensaver
- add gnome-screensaver autostart files
- add patch to remove obex file transfer

* Tue Jun 04 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.9.1-3
- add cinnamon-fedora.gschema.override file

* Tue Jun 04 2013 leigh scott <leigh123linux@googlemail.com> - 1.9.1-2
- patch for mozjs-17 changes

* Sat Jun 01 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.9.1-1
- Update to version 1.9.1

* Sat Jun 01 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.7-2
- Re-add build requires versions

* Sat Jun 01 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.7-1
- Update to version 1.8.7
- drop spice patch (now upstream)
- fix directory ownership and clenup files section

* Fri May 31 2013 leigh scott <leigh123linux@googlemail.com> - 1.8.6-2
- patch to fix spice download crash (bz 969162)

* Thu May 30 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.6-1
- Update to version 1.8.6
- patch to fix brightness applet (bz 967993)

* Wed May 22 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.5-3
- rebuild with release source and patch instead

* Wed May 22 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.5-2
- rebuild with new source

* Wed May 22 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.5-1
- Update to version 1.8.5

* Mon May 20 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.3-1
- Update to version 1.8.3
- drop telepathy and folks build requires
- Tidy up patches and drop merged patch

* Sun May 12 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.2-4
- fix missing backgrounds from cinnamon-settings

* Thu May 09 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.2-3
- fix notifications

* Thu May 09 2013 Leigh Scott <leigh123linux@googlemail.com> - 1.8.2-2
- add missing requires for settings

* Wed May 08 2013 Dan Mashal <dan.mashal@fedoraproject.org> 1.8.2-1
- Initial build of 1.8.2
- Fix erroneous changelog date
- Fix gnome 3.8 compatability
- Fix RHBZ 920320 and probably some others
- Get rid of split subpackages (for sanity)

* Fri Feb 22 2013 Kalev Lember <kalevlember@gmail.com> - 1.6.7-7
- Rebuilt for cogl soname bump

* Wed Feb 20 2013 Kalev Lember <kalevlember@gmail.com> - 1.6.7-6
- Rebuilt for libgnome-desktop soname bump

* Mon Feb  4 2013 Toshio Kuratomi <toshio@fedoraproject.org> - 1.6.7-5
- Add patch that's been accepted upstream for pillow support

* Fri Jan 25 2013 Peter Robinson <pbrobinson@fedoraproject.org> 1.6.7-4
- Rebuild for new cogl

* Thu Dec 20 2012 Kalev Lember <kalevlember@gmail.com> - 1.6.7-3
- Rebuilt for libgnome-desktop3 3.7.3 soname bump

* Wed Nov 14 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.7-2
- change requires on main package

* Wed Nov 14 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.7-1
- update to 1.6.7 release
- split menu setting, settings and 2d into sub-packages

* Wed Nov 14 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.6-3
- drop requires libgnomekbd (rhbz 874218)
- fix error in datetime patch
- drop requires nemo and add to comps instead (rhbz 875197)

* Tue Nov 13 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.6-2
- add keyboard applet patch

* Sun Nov 11 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.6-1
- update to 1.6.6 release

* Wed Nov 07 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.4-2
- add requires gnome-panel (rhbz 872694)
- add requires libgnomekbd (rhbz 874218)

* Wed Oct 31 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.4-1
- update to 1.6.4 release
- change the default apps and panel launchers

* Sat Oct 20 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.3-1
- update to 1.6.3 release
- add license for cinnamon-menu-editor
- remove -OO from cinnamon-menu-editor script
- drop upstream patch

* Sat Oct 13 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.1-3
- autostart for gnome-screensaver so lock works
- mozilla desktop fix

* Tue Oct 09 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.1-2
- fix settings applet icons
- patch font size (Bzr 864050)

* Thu Sep 27 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.1-1
- update to 1.6.1 release

* Wed Sep 26 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.0-3
- remove requires nautilus and swap it for nemo
- drop nemo patch

* Tue Sep 18 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.0-2
- patch bluetooth applet

* Mon Sep 17 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.6.0-1
- update to 1.6.0 release
- drop upstream patches
- add requires python-imaging, gnome-python2-gconf and python-imaging
- patch to use nautilus instead of nemo

* Thu Aug 23 2012 Dan Horák <dan[at]danny.cz> - 1.5.2-6
- fix build without BlueTooth

* Fri Aug 17 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.5.2-5
- rebuilt for new cogl version
- patch bluetooth applet
- use patch to fix windows quick list applet
- patch for new cogl api

* Sun Aug 12 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.5.2-4
- Fix directory ownership

* Sun Jul 29 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.5.2-3
- Add requires nautilus for settings
- Remove fedora logo from package to enable generic spins

* Fri Jul 27 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.5.2-2
- patch systray applet

* Thu Jul 26 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.5.2-1
- update to 1.5.2 release

* Tue Jul 24 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.5.0-0.1.git49593cb
- Update to the latest snapshot
- Remove buildrequires telepathy-glib-devel, telepathy-logger-devel and folks-devel
- Drop obsolete patches
- Add buildrequires libsoup-devel libgnome-keyring-devel

* Sat Jul 21 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.10.git7959517
- Add requires accountsservice-libs

* Sat Jul 21 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.9.git7959517
- Add patch to port window settings to gsettings

* Fri Jul 20 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.8.git7959517
- filter provides and requires
- Remove requires dbus-x11
- Add -p to install

* Fri Jul 20 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.7.git7959517
- Remove %%define and rebase settings patch
- Hardcode version for patches
- Rearrange patches
- Use install rather than cp
- Fix scriptlets
- Remove hardcoded file name from %%prep
- Preserve timestamps in %%install
- Remove extension from manpage in %%files
- Add requires dbus-x11

* Fri Jul 20 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.6.git7959517
- Fix macro in comment rpmlint error

* Thu Jul 19 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.5.git7959517
- Correct spelling mistake
- Add descriptions for patches 

* Wed Jul 18 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.4.git7959517
- bump spec version to fix repo issue

* Wed Jul 18 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.3.git7959517
- bump spec version to fix repo issue

* Wed Jul 18 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.2.git7959517
- bump spec version to fix repo issue

* Wed Jul 18 2012 Leigh Scott <leigh123linux@googlemail.com> - 1.4.1-0.1.git7959517
- Update to the latest snapshot

* Mon May 28 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-5.UP1
- Silence glib-compile-schemas scriplets
- fix firefox patch for f17
- fix power applet for f16

* Mon May 28 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-4.UP1
- add notification patch

* Mon May 28 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-3.UP1
- change %%define to %%global
- fix files listed twice in %%files section
- version patches
- remove %%config from files (gnome-shell and gnome-menus doesn't use them
  for the equivalent files)
- drop login theme patch

* Sun May 27 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-2.UP1
- add configure option so it compiles on F17
- fix release tag

* Sun May 27 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-1.UP1
- update to 1.4.0.UP1-1

* Wed Mar 14 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-2
- fix un-themed shutdown

* Tue Mar 13 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.4.0-1
- update to 1.4.0

* Mon Feb 20 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.3.1-1
- update to 1.3.1
- remove static lib
- remove mozilla plugin

* Fri Feb 17 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.3.0-1
- update to 1.3.0 release

* Sun Jan 22 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.2.0-1
- update to 1.2.0 release
- add build requires muffin-devel
- add Br libgudev1-devel
- add only-show-in=GNOME to settings desktop file
- make changes for source changes, applets, settings and session added
- delete session files and use my own
- move settings from lib to usr (it had no libs)
- replace menu icon
- change description

* Wed Jan 04 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.1.3-2
- add requires gnome-session
- clean up spec file ready for review

* Mon Jan 02 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.1.3-1
- update to version 1.1.3

* Sun Jan 01 2012 Leigh Scott <leigh123linux@fedoraproject.org> - 1.1.2-2
- fix firefox launchers

* Fri Dec 30 2011 Leigh Scott <leigh123linux@fedoraproject.org> - 1.1.2-1
- first build based on gnome-shell srpm
- add session files

